aboutsummaryrefslogtreecommitdiff
path: root/dev/perl
diff options
context:
space:
mode:
authorrhatto <rhatto@370017ae-e619-0410-ac65-c121f96126d4>2008-04-23 15:55:29 +0000
committerrhatto <rhatto@370017ae-e619-0410-ac65-c121f96126d4>2008-04-23 15:55:29 +0000
commitc0ef2e8d90a424e5f475959156fd391c0d9b54cb (patch)
tree02dd21c366d55059490bfa10dce820ed22763d74 /dev/perl
parent2f281febb36536dbedb19bb338cf51dfb69e9deb (diff)
downloadslackbuilds-c0ef2e8d90a424e5f475959156fd391c0d9b54cb.tar.gz
slackbuilds-c0ef2e8d90a424e5f475959156fd391c0d9b54cb.tar.bz2
perl-module-build: rebuilt from mkbuild
git-svn-id: svn+slack://slack.fluxo.info/var/svn/slackbuilds@1782 370017ae-e619-0410-ac65-c121f96126d4
Diffstat (limited to 'dev/perl')
-rwxr-xr-xdev/perl/perl-module-build/perl-module-build.SlackBuild183
1 files changed, 99 insertions, 84 deletions
diff --git a/dev/perl/perl-module-build/perl-module-build.SlackBuild b/dev/perl/perl-module-build/perl-module-build.SlackBuild
index a2c5f760..9d410c20 100755
--- a/dev/perl/perl-module-build/perl-module-build.SlackBuild
+++ b/dev/perl/perl-module-build/perl-module-build.SlackBuild
@@ -1,112 +1,130 @@
#!/bin/bash
#
-# perl-module-build.SlackBuild is free software; you can redistribute it and/or modify it under the
-# terms of the GNU General Public License as published by the Free Software
-# Foundation; either version 2 of the License, or any later version.
+# perl-module-build.SlackBuild is free software; you can redistribute
+# it and/or modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation; either version 2 of the License,
+# or any later version.
#
-# perl-module-build.SlackBuild is distributed in the hope that it will be useful, but WITHOUT ANY
-# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
-# A PARTICULAR PURPOSE. See the GNU General Public License for more details.
+# perl-module-build.SlackBuild is distributed in the hope that it will
+# be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+# Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place - Suite 330, Boston, MA 02111-1307, USA
#
-# SlackBuild script for perl-module-build
-# by rhatto at riseup.net by rhatto | gpl
-
-CWD="`pwd`"
-
-if [ -s "slack-required" ]; then
- echo Recomended and required packages for building ekiga are:
- cat slack-required | sed -e 's/^/\t/'
- if [ "$INTERACT" != "no" ]; then
- echo If you dont have those installed, press Ctrl-C. Otherwise, hit ENTER.
- read crap
-# else
-# echo Sleeping 3 seconds...
-# sleep 3
- fi
-fi
-
-if [ -f "/etc/slackbuildrc" ]; then
- source /etc/slackbuildrc
-fi
+# slackbuild for perl-module-build, by Silvio Rhatto
+# requires:
+# tested: perl-module-build-0.2808
+#
-if [ -f "~/.slackbuildrc" ]; then
+# Look for slackbuildrc
+if [ -f ~/.slackbuildrc ]; then
source ~/.slackbuildrc
+elif [ -f /etc/slackbuildrc ]; then
+ source /etc/slackbuildrc
fi
-# default settings
-NAME="Module::Build"
-PACKAGE="perl-`echo $NAME | sed -e 's/::/-/g' | tr '[:upper:]' '[:lower:]'`"
-TMP=${TMP:=/tmp}
-VERSION=${VERSION:=0.2805_01}
-ARCH=${ARCH:=i386}
+# Set variables
+CWD="$(pwd)"
+SRC_NAME="Module-Build"
+PKG_NAME="perl-module-build"
+ARCH=${ARCH:=i486}
+SRC_VERSION=${VERSION:=0.2808}
+PKG_VERSION="$(echo "$SRC_VERSION" | tr '[[:blank:]-]' '_')"
BUILD=${BUILD:=1rha}
-SRC_DIR=${SRC:=$CWD}
+SRC_DIR=${SRC_DIR:=$CWD}/$PKG_NAME
+TMP=${TMP:=/tmp}
+PKG=${PKG:=$TMP/package-$PKG_NAME}
REPOS=${REPOS:=$TMP}
+PREFIX=${PREFIX:=/usr}
+PKG_WORK="$TMP/$SRC_NAME"
+CONF_OPTIONS=${CONF_OPTIONS:=""}
+NUMJOBS=${NUMJOBS:=""}
+
+# Set system libraries' path and optmization flags based on $ARCH
+LIBDIR="$PREFIX/lib"
+
+if [ "$ARCH" = "i386" ]; then
+ SLKCFLAGS="-O2 -march=i386 -mcpu=i686"
+elif [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mcpu=i686"
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686"
+elif [ "$ARCH" = "s390" ]; then
+ SLKCFLAGS="-O2"
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2"
+ LIBDIR="$PREFIX/lib64"
+fi
-# ------- error codes for createpkg --------------
+# Set error codes (used by createpkg)
ERROR_WGET=31; ERROR_MAKE=32; ERROR_INSTALL=33
ERROR_MD5=34; ERROR_CONF=35; ERROR_HELP=36
ERROR_TAR=37; ERROR_MKPKG=38; ERROR_GPG=39
-ERROR_PATCH=40
+ERROR_PATCH=40; ERROR_VCS=41; ERROR_MKDIR=42
-if [ "$ARCH" == "x86_64" ]; then
- LIBDIR=/usr/lib64
-else
- LIBDIR=/usr/lib
-fi
+# Clean up any leftovers of previous builds
+rm -rf "$PKG_SRC" 2> /dev/null
+rm -rf "$PKG" 2> /dev/null
-RTOOL="wget"
-PACKAGE_EXT="gz"
-SRC="$PACKAGE-$VERSION.tar.$PACKAGE_EXT"
-FILE_NAME="`echo $NAME | sed -e 's/::/-/g'`"
-SRC="$FILE_NAME-$VERSION.tar.gz"
-URL="http://search.cpan.org/CPAN/authors/id/K/KW/KWILLIAMS/$SRC"
+# Create directories if necessary
+mkdir -p "$SRC_DIR" || exit $ERROR_MKDIR
+mkdir -p "$PKG" || exit $ERROR_MKDIR
+mkdir -p "$REPOS" || exit $ERROR_MKDIR
+mkdir -p "$PKG_WORK" || exit $ERROR_MKDIR
-SRC_DIR="$SRC_DIR/$PACKAGE"
-
-if [ ! -d "$SRC_DIR" ]; then
- mkdir -p $SRC_DIR
-fi
+# Dowload source if necessary
+SRC="$SRC_NAME-$VERSION.tar.gz"
+URL="http://search.cpan.org/CPAN/authors/id/K/KW/KWILLIAMS/$SRC"
-if [ "$RTOOL" == "wget" ] && [ ! -f "$SRC_DIR/$SRC" ]; then
+if [ ! -s "$SRC_DIR/$SRC" ] || ! gunzip -t "$SRC_DIR/$SRC" 2> /dev/null; then
wget "$URL" -O "$SRC_DIR/$SRC" || exit $ERROR_WGET
fi
-TMP="$TMP/$PACKAGE"
-
-if [ ! -d "$TMP" ]; then
- mkdir -p $TMP
-fi
-
-tar xvf $SRC_DIR/$SRC || exit $ERROR_TAR
-cd $FILE_NAME-$VERSION
-
-# config and install!
-mkdir -p /install
+# Untar
+cd "$PKG_WORK"
+tar --no-same-owner --no-same-permissions -xvf "$SRC_DIR/$SRC" || exit $ERROR_TAR
+PKG_SRC=`ls -l | awk '/^d/ { print $8 }'`
+cd "$PKG_SRC"
+# Configure
perl Makefile.PL || exit $ERROR_CONF
-make || exit $ERROR_MAKE
-make test
-make install DESTDIR=$TMP/package-$PACKAGE || exit $ERROR_INSTALL
-# make the package
+# Compile
+make $NUMJOBS || exit $ERROR_MAKE
-cd $TMP/package-$PACKAGE
+# Install
+make install DESTDIR="$PKG" || exit $ERROR_INSTALL
-# we need to fix .packlist
-string="`echo $TMP/package-$PACKAGE | sed -e 's/\//\\\\\//g'`"
-for file in `find -name .packlist`; do
+# Fix .packlist
+string="`echo $PKG | sed -e 's/\//\\\\\//g'`"
+for file in `find $PKG -name .packlist`; do
sed -e "s/^$string//g" $file > $file.tmp
mv $file.tmp $file
done
-mkdir install
+# Strip binaries
+( cd "$PKG"
+ find . | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | \
+ xargs strip --strip-unneeded 2> /dev/null
+ find . | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | \
+ xargs strip --strip-unneeded 2> /dev/null
+)
+
+# Install documentation
+DOCS="NEWS TODO README AUTHORS INSTALL ChangeLog MAINTAINERS COPYING LICENSE SIGNATURE readme.*"
+mkdir -p "$PKG/usr/doc/$PKG_NAME-$PKG_VERSION" || exit $ERROR_MKDIR
+for doc in $DOCS; do
+ if [ -f "$doc" ]; then
+ cp -a $doc "$PKG/usr/doc/$PKG_NAME-$PKG_VERSION"
+ fi
+done
-cat << EOF > install/slack-desc
+# Add package description (slack-desc)
+mkdir -p "$PKG/install" || exit $ERROR_MKDIR
+cat << EODESC > "$PKG/install/slack-desc"
# HOW TO EDIT THIS FILE:
# The "handy ruler" below makes it easier to edit a package description. Line
# up the first '|' above the ':' following the base package name, and the '|'
@@ -114,7 +132,7 @@ cat << EOF > install/slack-desc
# make exactly 11 lines for the formatting to be correct. It's also
# customary to leave one space after the ':'.
- |-----handy-ruler-----------------------------------------------------|
+ |-----handy-ruler--------------------------------------------|
perl-module-build: perl-module-build (Build and install Perl modules)
perl-module-build:
perl-module-build:
@@ -126,16 +144,13 @@ perl-module-build:
perl-module-build:
perl-module-build:
perl-module-build:
-EOF
+EODESC
-# docs
-mkdir -p usr/doc/$PACKAGE-$VERSION
-DOCS="Changes README SIGNATURE"
-cp -a $CWD/$DOCS usr/doc/$PACKAGE-$VERSION/
-
-makepkg -c y -l y $REPOS/$PACKAGE-$VERSION-$ARCH-$BUILD.tgz || exit $ERROR_MKPKG
+# Build the package
+cd "$PKG"
+makepkg -l y -c n "$REPOS/$PKG_NAME-$PKG_VERSION-$ARCH-$BUILD.tgz" || exit $ERROR_MKPKG
+# Delete source and build directories if requested
if [ "$CLEANUP" == "yes" ]; then
- rm -rf $TMP
+ rm -rf "$PKG_WORK" "$PKG"
fi
-